package com.viettel.campaign.service.impl;

import com.viettel.campaign.repository.CampaignRepository;
import com.viettel.campaign.service.CampaignService;
import com.viettel.campaign.utils.Constants;
import com.viettel.campaign.web.dto.ResultDTO;
import com.viettel.campaign.web.dto.request_dto.CampaignRequestDTO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

@Service
public class CampaignServiceImpl implements CampaignService {

    @Autowired
    CampaignRepository campaignRepository;

    @Override
    public ResultDTO searchCampaignExecute(CampaignRequestDTO requestDto) {
        return campaignRepository.searchCampaignExecute(requestDto);
    }

    @Override
    public ResultDTO search(CampaignRequestDTO requestDto) {
        return campaignRepository.search(requestDto);
    }

    @Override
    public ResultDTO findByCampaignCode(CampaignRequestDTO requestDTO) {
        return campaignRepository.findByCampaignCode(requestDTO);
    }

    @Override
    public Map countRecallCustomer(Long companySiteId, Long agentId) {
        Map result = new HashMap();
        Long count = campaignRepository.countRecallCustomer(companySiteId, agentId);
        ResultDTO resultDTO = new ResultDTO();
        if (count != null) {
            resultDTO.setErrorCode(Constants.ApiErrorCode.SUCCESS);
            resultDTO.setDescription(Constants.ApiErrorDesc.SUCCESS);
            result.put("info", resultDTO);
            result.put("result", count);
        } else {
            resultDTO.setErrorCode(Constants.ApiErrorCode.ERROR);
            resultDTO.setDescription(Constants.ApiErrorDesc.ERROR);
            result.put("info", resultDTO);
            result.put("result", 0);
        }

        return result;
    }
}
